#include <iostream>
#include <fstream>
#include <cctype>  // wegen isalpha
#include <string>
#include <map>
#include <functional> //wg. greater
#include <iomanip> // wegen setw
using namespace std;

int mainComplex() {
   typedef map<string, int, greater<string> > T_WordCntMap;
   T_WordCntMap wordCntMap;

   // Datei zum Einlesen oeffnen und abbrechen bei Fehler
   ifstream datei(".\\testFileCpp.txt", ios::in);
   if (!datei.good())  {
      cerr << "datei konnte nicht geoeffnet werden." << endl;
      exit(-1);
   }

   // Von Anfang bis Dateiende
   while (datei.good())    {
      string word;
      // Das nchste Wort aus der Datei einlesen.
      datei >> word;
      // Wort fuer Wort aus der Zeile extrahieren
      if ((word.size() > 1) && isalpha(word[0]))    {
         ++wordCntMap[word];
      }
   } // while (datei. good()

   // Ausgabe der Worte alphabetisch absteigend
   for (auto& iter : wordCntMap) {
      if (iter.second > 2)   {
         cout << setw(15) << iter.first << " : "
            << setw(5) << iter.second << endl;
      }
   }

   return 0;
}



int main() {
   map<string, int, greater<string> > wordCntMap;
   ifstream datei(".\\testFileCpp.txt", ios::in);
   // Von Anfang bis Dateiende
   while (datei.good())    {
      string word;
      // Das nchste Wort aus der Datei einlesen.
      datei >> word;
      // Wort fuer Wort aus der Zeile extrahieren
      if ((word.size() > 1) && isalpha(word[0]))       {
         ++wordCntMap[word];
      }
   } // while (datei. good()

   // Ausgabe der Worte alphabetisch absteigend
   for (auto& iter : wordCntMap) {
      if (iter.second > 2) {
         cout << setw(15) << iter.first << " : "
            << setw(5) << iter.second << endl;
      }
   }
}

